-- basic configurations
require("config")

-- -- -- --     TESTING / PROTOTYPING     -- -- -- -- -- 
-- require("prototypes.roboport")



require("prototypes.category")

require("prototypes.technology.technology")

require("prototypes.technology.inserter-stack-size-bonus")
require("prototypes.technology.laboratory-speed")
require("prototypes.technology.logslots")
require("prototypes.technology.robotcapacity")
require("prototypes.technology.robotspeed")
require("prototypes.technology.trashslots")

require("prototypes.technology.laser-turret-upgrades")


require("prototypes.item.faster-inserters")
require("prototypes.recipe.faster-inserters")
require("prototypes.entity.faster-inserters")
require("prototypes.fastertrain")
require("prototypes.betterroboport")
require("prototypes.parquet")

require("prototypes.powerbox")
require("prototypes.pollutiongenerator")


require("prototypes.equipment")
require("prototypes.strongerlaserturret")

require("prototypes.item.medium-electric-poles")
require("prototypes.recipe.medium-electric-poles")
require("prototypes.entity.medium-electric-poles")
require("prototypes.item.big-electric-poles")
require("prototypes.recipe.big-electric-poles")
require("prototypes.entity.big-electric-poles")
require("prototypes.waterpump")
require("prototypes.item.basic-mining-drills")
require("prototypes.recipe.basic-mining-drills")
require("prototypes.entity.basic-mining-drills")
require("prototypes.item.pumpjacks")
require("prototypes.recipe.pumpjacks")
require("prototypes.entity.pumpjacks")
require("prototypes.barrelingfacility")
require("prototypes.item.electric-furnaces")
require("prototypes.recipe.electric-furnaces")
require("prototypes.entity.electric-furnaces")
require("prototypes.item.assembling-machines")
require("prototypes.recipe.assembling-machines")
require("prototypes.entity.assembling-machines")
require("prototypes.item.oil-refineries")
require("prototypes.recipe.oil-refineries")
require("prototypes.entity.oil-refineries")
require("prototypes.item.chemical-plants")
require("prototypes.recipe.chemical-plants")
require("prototypes.entity.chemical-plants")


-- bigger stack sizes
if Settings.IncreaseStackSizes then
	local StackSize = Settings.Max_Stacksize
	local factor_default = Settings.Stacksize_Factor_Default
	local factor_barrel = Settings.Stacksize_Factor_Barrel

	for _,dat in pairs(data.raw) do
	   	for _,items in pairs(dat) do
	      	if items.stack_size and items.stack_size > 1 and items.stack_size < StackSize then
	           	if items.stack_size * factor_default < StackSize then
					if string.find(items.name, "barrel") then
						items.stack_size = items.stack_size * factor_barrel
					else
						items.stack_size = items.stack_size * factor_default
					end
				else
					items.stack_size = StackSize
				end
	      	end
	   	end
	end
end


-- increase transport belt underground distance
if Settings.IncreaseUndergroundBeltDistance then
	data.raw["transport-belt-to-ground"]["basic-transport-belt-to-ground"].max_distance = Settings.Yellow_Underground_Distance
	data.raw["transport-belt-to-ground"]["fast-transport-belt-to-ground"].max_distance = Settings.Red_Underground_Distance
	data.raw["transport-belt-to-ground"]["express-transport-belt-to-ground"].max_distance = Settings.Blue_Underground_Distance
end


-- improve repair packs
if Settings.ImproveRepairPacks then
	local repairitem = util.table.deepcopy(data.raw["repair-tool"]["repair-pack"])
	repairitem.speed = repairitem.speed * 10
	repairitem.durability = repairitem.durability * 10
	data:extend{repairitem}
end


-- enemy bitters can drop alien artifacts
if Settings.BittersDropArtifacts then
	if data.raw.item["alien-artifact"] then
		if data.raw.unit["medium-biter"] then
		  	if data.raw.unit["medium-biter"].loot == nil then 
		    	data.raw.unit["medium-biter"].loot = {}
		  	end
		  	table.insert(data.raw.unit["medium-biter"].loot, {  item = "alien-artifact",  count_min = 1,  count_max = 2,  probability = 0.01 } )
		end
		if data.raw.unit["big-biter"] then
			if data.raw.unit["big-biter"].loot == nil then 
		    	data.raw.unit["big-biter"].loot = {}
		  	end
		  	table.insert(data.raw.unit["big-biter"].loot, {  item = "alien-artifact",  count_min = 1,  count_max = 2,  probability = 0.02 } )
		end
		if data.raw.unit["behemoth-biter"] then
			if data.raw.unit["behemoth-biter"].loot == nil then 
		    	data.raw.unit["behemoth-biter"].loot = {}
		  	end
		  	table.insert(data.raw.unit["behemoth-biter"].loot, {  item = "alien-artifact",  count_min = 1,  count_max = 5,  probability = 0.01 } )
		end
		if data.raw.unit["small-spitter"] then
			if data.raw.unit["small-spitter"].loot == nil then 
		    	data.raw.unit["small-spitter"].loot = {}
		  	end
		  	table.insert(data.raw.unit["small-spitter"].loot, {  item = "alien-artifact",  count_min = 1,  count_max = 1,  probability = 0.01 } )
		end
		if data.raw.unit["medium-spitter"] then
			if data.raw.unit["medium-spitter"].loot == nil then 
		    	data.raw.unit["medium-spitter"].loot = {}
		  	end
		  	table.insert(data.raw.unit["medium-spitter"].loot, {  item = "alien-artifact",  count_min = 1,  count_max = 2,  probability = 0.01 } )
		end
		if data.raw.unit["big-spitter"] then
			if data.raw.unit["big-spitter"].loot == nil then 
		    	data.raw.unit["big-spitter"].loot = {}
		  	end
		  	table.insert(data.raw.unit["big-spitter"].loot, {  item = "alien-artifact",  count_min = 1,  count_max = 2,  probability = 0.02 } )
		end
		if data.raw.unit["behemoth-spitter"] then
			if data.raw.unit["behemoth-spitter"].loot == nil then 
		    	data.raw.unit["behemoth-spitter"].loot = {}
		  	end
		  	table.insert(data.raw.unit["behemoth-spitter"].loot, {  item = "alien-artifact",  count_min = 1,  count_max = 5,  probability = 0.01 } )
		end
	end
end

-- improve base robot
local logrobot = util.table.deepcopy(data.raw["logistic-robot"]["logistic-robot"])
-- logrobot.transfer_distance = 0.5
logrobot.max_energy = "1.3MJ"
logrobot.energy_per_move = "130J"
data:extend{logrobot}
local constrobot = util.table.deepcopy(data.raw["construction-robot"]["construction-robot"])
-- constrobot.transfer_distance = 0.5
constrobot.max_energy = "1.3MJ"
constrobot.energy_per_move = "130J"
data:extend{constrobot}


local mplayer = util.table.deepcopy(data.raw["player"]["player"])
-- I don't like dying
mplayer.max_health = "-1"
mplayer.healing_per_tick = "0"

-- walking improvements
mplayer.running_speed = mplayer.running_speed * 3
-- reduce player collisions, for easier walking in woods and between chests
mplayer.collision_box = {{-0.01, -0.01}, {0.01, 0.01}}

mplayer.mining_speed = mplayer.mining_speed * 5

-- increase reach
if Settings.IncreaseReach then
	mplayer.build_distance = Settings.Reach_Distance
	mplayer.drop_item_distance = Settings.Reach_Distance
	mplayer.reach_distance = Settings.Reach_Distance
	mplayer.reach_resource_distance = mplayer.reach_resource_distance * 2
end

-- afraid in the dark ?
if Settings.MoreLight then
	mplayer.light =
	{
	   minimum_darkness = 0.3,
	   intensity = 0.9,
	   size = 250
	}
end

-- larger inventory
if Settings.IncreaseInventorySize then
	mplayer.inventory_size = Settings.Inventory_Size
end
data:extend{mplayer}