local reactoritem = util.table.deepcopy(data.raw["item"]["fusion-reactor-equipment"])
reactoritem.name = "m-fozzy-fusion-reactor-equipment"
reactoritem.placed_as_equipment_result = "m-fozzy-fusion-reactor-equipment"
reactoritem.order = "a[energy-source]-c[m-fozzy-fusion-reactor-equipment]"
data:extend{reactoritem}

local exoitem = util.table.deepcopy(data.raw["item"]["basic-exoskeleton-equipment"])
exoitem.name = "m-speed-boots-equipment"
exoitem.placed_as_equipment_result = "m-speed-boots-equipment"
exoitem.order = "e[exoskeleton]-b[m-speed-boots-equipment]"
data:extend{exoitem}

local personalroboitem = util.table.deepcopy(data.raw["item"]["personal-roboport-equipment"])
personalroboitem.name = "m-cozy-personal-roboport-equipment"
personalroboitem.placed_as_equipment_result = "m-cozy-personal-roboport-equipment"
personalroboitem.order = "e[robotics]-b[m-cozy-personal-roboport-equipment]"
data:extend{personalroboitem}


local reactorequipment = util.table.deepcopy(data.raw["generator-equipment"]["fusion-reactor-equipment"])
reactorequipment.name = "m-fozzy-fusion-reactor-equipment"
reactorequipment.power = "750kW" -- "75kW"    x 10
data:extend{reactorequipment}

local exoequipment = util.table.deepcopy(data.raw["movement-bonus-equipment"]["basic-exoskeleton-equipment"])
exoequipment.name = "m-speed-boots-equipment"
exoequipment.energy_consumption =  "70kW" -- "20kW"    x 3.5
exoequipment.movement_bonus = exoequipment.movement_bonus * 5
data:extend{exoequipment}

local personalroboequipment = util.table.deepcopy(data.raw["roboport-equipment"]["personal-roboport-equipment"])
personalroboequipment.name = "m-cozy-personal-roboport-equipment"
personalroboequipment.robot_limit = personalroboequipment.robot_limit * 5
personalroboequipment.construction_radius = personalroboequipment.construction_radius * 5
personalroboequipment.charging_station_count = personalroboequipment.charging_station_count * 10
data:extend{personalroboequipment}


local reactorrecipe = util.table.deepcopy(data.raw["recipe"]["fusion-reactor-equipment"])
reactorrecipe.name = "m-fozzy-fusion-reactor-equipment"
reactorrecipe.ingredients =
    {
      {"fusion-reactor-equipment", 10},
      {"steel-plate", 10}
    }
reactorrecipe.result = "m-fozzy-fusion-reactor-equipment"
data:extend{reactorrecipe}

local reactorrecipe = util.table.deepcopy(data.raw["recipe"]["basic-exoskeleton-equipment"])
reactorrecipe.name = "m-speed-boots-equipment"
reactorrecipe.ingredients =
    {
      {"basic-exoskeleton-equipment", 5},
      {"steel-plate", 5}
    }
reactorrecipe.result = "m-speed-boots-equipment"
data:extend{reactorrecipe}

local reactorrecipe = util.table.deepcopy(data.raw["recipe"]["personal-roboport-equipment"])
reactorrecipe.name = "m-cozy-personal-roboport-equipment"
reactorrecipe.ingredients =
    {
      {"personal-roboport-equipment", 5},
      {"steel-plate", 5}
    }
reactorrecipe.result = "m-cozy-personal-roboport-equipment"
data:extend{reactorrecipe}

local improvedequipmenttech = util.table.deepcopy(data.raw["technology"]["fusion-reactor-equipment"])
improvedequipmenttech.name = "m-improved-equipment-tech"
improvedequipmenttech.icon = "__base__/graphics/icons/basic-exoskeleton-equipment.png"
improvedequipmenttech.prerequisites = 
{
	"fusion-reactor-equipment",
	"personal-roboport-equipment",
	"basic-exoskeleton-equipment",
}
improvedequipmenttech.unit = {
    count = 300,
    ingredients =
    {
      {"science-pack-1", 1},
      {"science-pack-2", 1},
      {"science-pack-3", 1}
    },
    time = 30
  }
improvedequipmenttech.effects = {
    {
      type = "unlock-recipe",
      recipe = "m-fozzy-fusion-reactor-equipment"
    },
    {
      type = "unlock-recipe",
      recipe = "m-speed-boots-equipment"
    },
    {
      type = "unlock-recipe",
      recipe = "m-cozy-personal-roboport-equipment"
    },
  }
data:extend{improvedequipmenttech}