
local pollutiongeneratoritem = util.table.deepcopy(data.raw["item"]["steel-furnace"])
pollutiongeneratoritem.name = "m-pollution-generator"
pollutiongeneratoritem.icon = "__mmod__/graphics/icons/m-pollution-generator.png"
-- todo: find better location ...
pollutiongeneratoritem.subgroup = "module"
pollutiongeneratoritem.order = "a[m-pollution-generator]"
pollutiongeneratoritem.place_result = "m-pollution-generator"
data:extend{pollutiongeneratoritem}

data:extend({
  {
    type = "recipe",
    name = "m-pollution-generator",
    energy_required = 3,
    enabled = "true",
    ingredients =
    {
      {"steel-furnace", 4}
    },
    result = "m-pollution-generator"
  },
  {
    type = "recipe-category",
    name = "polluting"
  },
  {
    type = "recipe",
    name = "m-pollute",
    icon = "__base__/graphics/icons/coal.png",
    category = "polluting",
    order = "f[plastic-bar]-f[m-pollute]",
    energy_required = 13000,
    enabled = "true",
    ingredients =
    {
      {"coal", 100}
    },
    result = "alien-artifact"
  },
  {
    type = "recipe",
    name = "m-pollute2",
    icon = "__base__/graphics/icons/raw-wood.png",
    category = "polluting",
    order = "f[m-pollute]-f[m-pollute2]",
    energy_required = 13000,
    enabled = "true",
    ingredients =
    {
      {"raw-wood", 100}
    },
    result = "alien-artifact"
  }
})

local pollutiongenerator = util.table.deepcopy(data.raw["assembling-machine"]["assembling-machine-3"])
pollutiongenerator.name="m-pollution-generator"
pollutiongenerator.minable.result="m-pollution-generator"
pollutiongenerator.icon = "__mmod__/graphics/icons/m-pollution-generator.png"
pollutiongenerator.crafting_categories = {"polluting"}
-- entity size: 4x4
pollutiongenerator.animation = {
      filename = "__base__/graphics/entity/steel-furnace/steel-furnace-working.png",
      priority = "high",
      width = 140,
      height = 76,
      frame_count = 1,
      shift = {1.828125, -0.11875},
      scale = 1.5,
      tint = {r=.3,g=1,b=.08,a=1}
    }
pollutiongenerator.idle_animation = {
      filename = "__base__/graphics/entity/steel-furnace/steel-furnace-idle.png",
      priority = "high",
      width = 140,
      height = 76,
      frame_count = 1,
      shift = {1.828125, -0.11875},
      scale = 1.5,
    }
pollutiongenerator.working_visualisations = {
  {
    north_position = {0.0, 0.0},
    east_position = {0.0, 0.0},
    south_position = {0.0, 0.0},
    west_position = {0.0, 0.0},
    animation = {
      filename = "__base__/graphics/entity/steel-furnace/steel-furnace-fire.png",
      priority = "high",
      width = 21,
      height = 9,
      frame_count = 28,
      scale = 1.53,
      shift = {0.0703125, 0.9609375}
    },
    light = {intensity = 1, size = 1}
  },
  {
    north_position = {0.0, 0.0},
    east_position = {0.0, 0.0},
    south_position = {0.0, 0.0},
    west_position = {0.0, 0.0},
    effect = "flicker", -- changes alpha based on energy source light intensity
    animation = {
      filename = "__base__/graphics/entity/steel-furnace/steel-furnace-glow.png",
      priority = "high",
      width = 60,
      height = 43,
      frame_count = 1,
      scale = 1.5,
      shift = {0.046875, 0.9609375},
      blend_mode = "additive"
    }
  },
}
pollutiongenerator.max_health = Health.Tier5
pollutiongenerator.fast_replaceable_group = "pollution-generator"
pollutiongenerator.collision_box = {{-1.35, -1.35}, {1.35, 1.35}}
pollutiongenerator.selection_box = {{-1.2, -1.5}, {1.2, 1.5}}
pollutiongenerator.fluid_boxes ={}
pollutiongenerator.crafting_speed = 3
pollutiongenerator.energy_source =  {
    type = "electric",
    usage_priority = "secondary-input",
    emissions = 13
  }
data:extend{pollutiongenerator}




 -- {
 --    type = "furnace",
 --    name = "steel-furnace",
 --    icon = "__base__/graphics/icons/steel-furnace.png",
 --    flags = {"placeable-neutral", "placeable-player", "player-creation"},
 --    minable = {mining_time = 1, result = "steel-furnace"},
 --    max_health = 200,
 --    corpse = "medium-remnants",
 --    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
 --    working_sound =
 --    {
 --      sound = { filename = "__base__/sound/furnace.ogg" }
 --    },
 --    resistances =
 --    {
 --      {
 --        type = "fire",
 --        percent = 100
 --      }
 --    },
 --    collision_box = {{-0.7, -0.7}, {0.7, 0.7}},
 --    selection_box = {{-0.8, -1}, {0.8, 1}},
 --    crafting_categories = {"smelting"},
 --    result_inventory_size = 1,
 --    energy_usage = "180kW",
 --    crafting_speed = 2,
 --    source_inventory_size = 1,
 --    energy_source =
 --    {
 --      type = "burner",
 --      effectivity = 1,
 --      emissions = 0.02,
 --      fuel_inventory_size = 1,
 --      smoke =
 --      {
 --        {
 --          name = "smoke",
 --          frequency = 10,
 --          position = {0.7, -1.2},
 --          starting_vertical_speed = 0.08,
 --          starting_frame_deviation = 60
 --        }
 --      }
 --    },
 --    animation =
 --    {
 --      filename = "__base__/graphics/entity/steel-furnace/steel-furnace-working.png",
 --      priority = "high",
 --      width = 140,
 --      height = 76,
 --      frame_count = 1,
 --      shift = {1.21875, -0.125}
 --    },
 --    idle_animation =
 --    {
 --      filename = "__base__/graphics/entity/steel-furnace/steel-furnace-idle.png",
 --      priority = "high",
 --      width = 140,
 --      height = 76,
 --      frame_count = 1,
 --      shift = {1.21875, -0.125}
 --    },
 --    working_visualisations =
 --    {
 --      {
 --        north_position = {0.0, 0.0},
 --        east_position = {0.0, 0.0},
 --        south_position = {0.0, 0.0},
 --        west_position = {0.0, 0.0},
 --        animation =
 --        {
 --          filename = "__base__/graphics/entity/steel-furnace/steel-furnace-fire.png",
 --          priority = "high",
 --          width = 21,
 --          height = 9,
 --          frame_count = 28,
 --          scale = 1.02,
 --          shift = {0.046875, 0.640625}
 --        },
 --        light = {intensity = 1, size = 1}
 --      },
	--   {
 --        north_position = {0.0, 0.0},
 --        east_position = {0.0, 0.0},
 --        south_position = {0.0, 0.0},
 --        west_position = {0.0, 0.0},
 --        effect = "flicker", -- changes alpha based on energy source light intensity
 --        animation =
 --        {
 --          filename = "__base__/graphics/entity/steel-furnace/steel-furnace-glow.png",
 --          priority = "high",
 --          width = 60,
 --          height = 43,
 --          frame_count = 1,
 --          shift = {0.03125, 0.640625},
 --          blend_mode = "additive"
 --        }
 --      },
 --    },
 --    fast_replaceable_group = "furnace"
 --  }