local powerboxitem = util.table.deepcopy(data.raw["item"]["steam-engine"])
powerboxitem.name = "m-power-box"
powerboxitem.icon = "__mmod__/graphics/icons/power-box.png"
powerboxitem.place_result = "m-power-box"
powerboxitem.order = "b[steam-power]-aa[m-power-box]"
data:extend{powerboxitem}

data:extend(
{
  {
    type = "fluid",
    name = "power",
    default_temperature = 0,
    max_temperature = 100,
    heat_capacity = "1GJ",
    base_color = {r=0.1, g=0.1, b=0.1},
    flow_color = {r=0.7, g=0.7, b=0.7},
    icon = "__mmod__/graphics/icons/power-box.png",
    order = "a[fluid]-z[power]",
    pressure_to_speed_ratio = 0.4,
    flow_to_energy_ratio = 0.59,
  },
}
)

data:extend(
{	
  {
    type = "generator",
    name = "m-power-box",
    icon = "__mmod__/graphics/icons/power-box.png",
    flags = {"placeable-neutral","player-creation"},
    minable = {mining_time = 1, result = "m-power-box"},
    max_health = 13000000,
    corpse = "big-remnants",
    effectivity = 1,
    fluid_usage_per_tick = 2600,
    resistances =
    {
      {
        type = "physical",
        percent = 100
      },
	  {
        type = "fire",
        percent = 100
      },
	  {
        type = "acid",
        percent = 100
      },
	  {
        type = "poison",
        percent = 100
      },
	  {
        type = "explosion",
        percent = 100
      },
	  {
        type = "laser",
        percent = 100
      }
    },
    collision_box = {{-0.58, -0.58}, {0.58, 0.58}},
    selection_box = {{-1, -1}, {1, 1}},
    fluid_box =
    {
      base_area = 1,			
      pipe_connections =
      {
        --{ position = {-1, 2} },
        --{ position = {-1,-2} },
      },
    },
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output"
    },
    horizontal_animation =
    {
	    filename = "__base__/graphics/entity/stone-wall/wall-single.png",
	    width = 22,
	    height = 42,
	    frame_count = 1,
	    line_length = 1,
	    shift = {0, -0.15625},
      	scale = 2,
	    tint = {r=0.3,g=0.3,b=0.1,a=1}
    },
    vertical_animation =
    {
	    filename = "__base__/graphics/entity/stone-wall/wall-single.png",
      	width = 22,
      	height = 42,
      	frame_count = 1,
      	line_length = 1,
      	shift = {0, -0.15625},
      	scale = 2,
	    tint = {r=0.3,g=0.1,b=0.3,a=1}
    },	
    smoke =
    {
    },
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/steam-engine-90bpm.ogg",
        volume = 0
      },
      match_speed_to_activity = true,
    },
    min_perceived_performance = 0.25,
    performance_to_sound_speedup = 0.2
  },
}
)
