data.raw["technology"]["logistic-robot-speed-2"].effects = {{type = "logistic-robot-speed", modifier = 0.40}}
data.raw["technology"]["logistic-robot-speed-3"].effects = {{type = "logistic-robot-speed", modifier = 0.50}}
data.raw["technology"]["logistic-robot-speed-4"].effects = {{type = "logistic-robot-speed", modifier = 0.60}}
data.raw["technology"]["logistic-robot-speed-5"].effects = {{type = "logistic-robot-speed", modifier = 0.70}}

local techn 
for i = 6,30 do 
  techn = util.table.deepcopy(data.raw["technology"]["logistic-robot-speed-3"])
  techn.name = "logistic-robot-speed-"..i
  techn.prerequisites = {"logistic-robot-speed-"..(i-1)}
  techn.effects = {
        {
          type = "logistic-robot-speed",
          modifier = 1 + (i * 0.05)
        }
      }
  techn.unit = {
      count = (i * 50) - 50,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1}
      },
      time = 60 + (2 * i)
    }
  data:extend{techn}
end

data:extend(
{
	  {
    type = "technology",
    name = "logistic-robot-speed-6",
    icon = "__base__/graphics/technology/logistic-robot-speed.png",
    effects = {
      {
        type = "logistic-robot-speed",
        modifier = "1"
      }
    },
    prerequisites = {
      "logistic-robot-speed-5"
    },
    unit = {
      count = 650,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
	{"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = "true",
    order = "c-k-f-a",
  },
  {
    type = "technology",
    name = "logistic-robot-speed-7",
    icon = "__base__/graphics/technology/logistic-robot-speed.png",
    effects = {
      {
        type = "logistic-robot-speed",
        modifier = "2"
      }
    },
    prerequisites = {
      "logistic-robot-speed-6"
    },
    unit = {
      count = 800,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
	{"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = "true",
    order = "c-k-f-a",
  },
  {
    type = "technology",
    name = "logistic-robot-speed-8",
    icon = "__base__/graphics/technology/logistic-robot-speed.png",
    effects = {
      {
        type = "logistic-robot-speed",
        modifier = "3"
      }
    },
    prerequisites = {
      "logistic-robot-speed-7"
    },
    unit = {
      count = 950,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
	{"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = "true",
    order = "c-k-f-a",
  },
  {
    type = "technology",
    name = "logistic-robot-speed-9",
    icon = "__base__/graphics/technology/logistic-robot-speed.png",
    effects = {
      {
        type = "logistic-robot-speed",
        modifier = "4"
      }
    },
    prerequisites = {
      "logistic-robot-speed-8"
    },
    unit = {
      count = 1100,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
	{"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = "true",
    order = "c-k-f-a",
  },
  {
    type = "technology",
    name = "logistic-robot-speed-10",
    icon = "__base__/graphics/technology/logistic-robot-speed.png",
    effects = {
      {
        type = "logistic-robot-speed",
        modifier = "5"
      }
    },
    prerequisites = {
      "logistic-robot-speed-9"
    },
    unit = {
      count = 1250,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
	{"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = "true",
    order = "c-k-f-a",
  },
  {
    type = "technology",
    name = "logistic-robot-speed-11",
    icon = "__base__/graphics/technology/logistic-robot-speed.png",
    effects = {
      {
        type = "logistic-robot-speed",
        modifier = "6"
      }
    },
    prerequisites = {
      "logistic-robot-speed-10"
    },
    unit = {
      count = 1500,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
	{"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = "true",
    order = "c-k-f-a",
  },
  {
    type = "technology",
    name = "logistic-robot-speed-12",
    icon = "__base__/graphics/technology/logistic-robot-speed.png",
    effects = {
      {
        type = "logistic-robot-speed",
        modifier = "7"
      }
    },
    prerequisites = {
      "logistic-robot-speed-11"
    },
    unit = {
      count = 2000,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
	{"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = "true",
    order = "c-k-f-a",
  },
  {
    type = "technology",
    name = "logistic-robot-speed-13",
    icon = "__base__/graphics/technology/logistic-robot-speed.png",
    effects = {
      {
        type = "logistic-robot-speed",
        modifier = "8"
      }
    },
    prerequisites = {
      "logistic-robot-speed-12"
    },
    unit = {
      count = 3000,
      ingredients = {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
	{"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = "true",
    order = "c-k-f-a",
  },
}  
  )
