data:extend(
{
  {
    type = "technology",
    name = "barrel-handling",
    icon = "__base__/graphics/icons/fluid/empty-barrel.png",
    prerequisites = 
    {
	     "fluid-handling"
    },
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "barreling-facility-m1"
      },
      {
        type = "unlock-recipe",
        recipe = "fill-water-barrel"
      },
	    {
        type = "unlock-recipe",
        recipe = "empty-water-barrel"
      },
      {
        type = "unlock-recipe",
        recipe = "fill-sulfuric-acid-barrel"
      },
	    {
        type = "unlock-recipe",
        recipe = "empty-sulfuric-acid-barrel"
      },
      {
        type = "unlock-recipe",
        recipe = "fill-lubricant-barrel"
      },
	    {
        type = "unlock-recipe",
        recipe = "empty-lubricant-barrel"
      },
      {
        type = "unlock-recipe",
        recipe = "fill-petroleum-gas-barrel"
      },
	    {
        type = "unlock-recipe",
        recipe = "empty-petroleum-gas-barrel"
      },
      {
        type = "unlock-recipe",
        recipe = "fill-heavy-oil-barrel"
      },
	    {
        type = "unlock-recipe",
        recipe = "empty-heavy-oil-barrel"
      },
      {
        type = "unlock-recipe",
        recipe = "fill-light-oil-barrel"
      },
	    {
        type = "unlock-recipe",
        recipe = "empty-light-oil-barrel"
      },
    },
    unit =
    {
      count = 50,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
      },
      time = 10
    },
    order = "e-f-a"
  },
  {
    type = "technology",
    name = "m-faster-inserters",
    icon = "__mmod__/graphics/icons/faster-inserter.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "m-faster-smart-inserter"
      },
      {
        type = "unlock-recipe",
        recipe = "m-faster-inserter"
      },
    },
    prerequisites =
    {
      "advanced-electronics",
      "logistics",
    },
    unit =
    {
      count = 50,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
      },
      time = 30
    },
    order = "a-f",
  },
  {
    type = "technology",
    name = "m1",
    icon = "__mmod__/graphics/icons/mmod-m1.png",
    prerequisites =
    {
      "automation-3",
      "electric-energy-distribution-1",
      "oil-processing",
      "advanced-material-processing-2",      
      "advanced-material-processing-2",
      "barrel-handling"
    },
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "medium-electric-pole-m1"
      },
      {
        type = "unlock-recipe",
        recipe = "big-electric-pole-m1"
      },
      {
        type = "unlock-recipe",
        recipe = "water-pump-m1"
      },
      {
        type = "unlock-recipe",
        recipe = "basic-mining-drill-m1"
      },
      {
        type = "unlock-recipe",
        recipe = "pumpjack-m1"
      },
      {
        type = "unlock-recipe",
        recipe = "electric-furnace-m1"
      },
      {
        type = "unlock-recipe",
        recipe = "assembling-machine-m1"
      },
      {
        type = "unlock-recipe",
        recipe = "oil-refinery-m1"
      },
      {
        type = "unlock-recipe",
        recipe = "chemical-plant-m1"
      },
    },
    unit =
    {
      count = 100,
      ingredients = 
      {
        {"science-pack-1", 1},
      },
      time = 10
    },
    upgrade = true,
    order = "d-c-c1"
  },
  {
    type = "technology",
    name = "m2",
    icon = "__mmod__/graphics/icons/mmod-m2.png",
    prerequisites =
    {
      "m1",
    },
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "medium-electric-pole-m2"
      },
      {
        type = "unlock-recipe",
        recipe = "big-electric-pole-m2"
      },
      {
        type = "unlock-recipe",
        recipe = "water-pump-m2"
      },
      {
        type = "unlock-recipe",
        recipe = "basic-mining-drill-m2"
      },
      {
        type = "unlock-recipe",
        recipe = "pumpjack-m2"
      },
      {
        type = "unlock-recipe",
        recipe = "barreling-facility-m2"
      },
      {
        type = "unlock-recipe",
        recipe = "electric-furnace-m2"
      },
      {
        type = "unlock-recipe",
        recipe = "assembling-machine-m2"
      },
      {
        type = "unlock-recipe",
        recipe = "oil-refinery-m2"
      },
      {
        type = "unlock-recipe",
        recipe = "chemical-plant-m2"
      },
    },
    unit =
    {
      count = 200,
      ingredients = 
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
      },
      time = 15
    },
    upgrade = true,
    order = "d-c-c2"
  },
  {
    type = "technology",
    name = "m3",
    icon = "__mmod__/graphics/icons/mmod-m3.png",
    prerequisites =
    {
      "m2",
    },
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "medium-electric-pole-m3"
      },
      {
        type = "unlock-recipe",
        recipe = "big-electric-pole-m3"
      },
      {
        type = "unlock-recipe",
        recipe = "water-pump-m3"
      },
      {
        type = "unlock-recipe",
        recipe = "basic-mining-drill-m3"
      },
      {
        type = "unlock-recipe",
        recipe = "pumpjack-m3"
      },
      {
        type = "unlock-recipe",
        recipe = "barreling-facility-m3"
      },
      {
        type = "unlock-recipe",
        recipe = "electric-furnace-m3"
      },
      {
        type = "unlock-recipe",
        recipe = "assembling-machine-m3"
      },
      {
        type = "unlock-recipe",
        recipe = "oil-refinery-m3"
      },
      {
        type = "unlock-recipe",
        recipe = "chemical-plant-m3"
      },
    },
    unit =
    {
      count = 300,
      ingredients = 
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
      },
      time = 20
    },
    upgrade = true,
    order = "d-c-c3"
  },
  {
    type = "technology",
    name = "m4",
    icon = "__mmod__/graphics/icons/mmod-m4.png",
    prerequisites =
    {
  	"m3",
    },
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "medium-electric-pole-m4"
      },
      {
        type = "unlock-recipe",
        recipe = "big-electric-pole-m4"
      },
      {
        type = "unlock-recipe",
        recipe = "water-pump-m4"
      },
      {
        type = "unlock-recipe",
        recipe = "basic-mining-drill-m4"
      },
      {
        type = "unlock-recipe",
        recipe = "pumpjack-m4"
      },
      {
        type = "unlock-recipe",
        recipe = "barreling-facility-m4"
      },
      {
        type = "unlock-recipe",
        recipe = "electric-furnace-m4"
      },
      {
        type = "unlock-recipe",
        recipe = "assembling-machine-m4"
      },
      {
        type = "unlock-recipe",
        recipe = "oil-refinery-m4"
      },
      {
        type = "unlock-recipe",
        recipe = "chemical-plant-m4"
      },
    },
    unit =
    {
      count = 400,
      ingredients = 
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1},
      },
      time = 25
    },
    upgrade = true,
    order = "d-c-c4"
  },
  {
    type = "technology",
    name = "m5",
    icon = "__mmod__/graphics/icons/mmod-m5.png",
    prerequisites =
    {
  	"m4",
    },
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "medium-electric-pole-m5"
      },
      {
        type = "unlock-recipe",
        recipe = "big-electric-pole-m5"
      },
      {
        type = "unlock-recipe",
        recipe = "water-pump-m5"
      },
      {
        type = "unlock-recipe",
        recipe = "basic-mining-drill-m5"
      },
      {
        type = "unlock-recipe",
        recipe = "pumpjack-m5"
      },
      {
        type = "unlock-recipe",
        recipe = "barreling-facility-m5"
      },
      {
        type = "unlock-recipe",
        recipe = "electric-furnace-m5"
      },
      {
        type = "unlock-recipe",
        recipe = "assembling-machine-m5"
      },
      {
        type = "unlock-recipe",
        recipe = "oil-refinery-m5"
      },
      {
        type = "unlock-recipe",
        recipe = "chemical-plant-m5"
      },
    },
    unit =
    {
      count = 500,
      ingredients = 
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1},
      },
      time = 30
    },
    upgrade = true,
    order = "d-c-c5"
  },

}
)
